unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, Dxcore,
  activex;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_WarpRollerRklist, U_WarpRollerCklist, U_WarpRollerkCList,
  U_EmptyRollerRklist, U_EmptyRollerkCList, U_EmptyRollerCklist,
  U_EquipmentRklist, U_EquipmentCklist, U_EquipmentkCList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if Trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
    dtbase := 'chenfengdata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';
//  server := '.';
//  dtbase := 'yiduidata';
//  user := 'sa';
//  pswd := 'rightsoft';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  end
  else
  begin
    DConString := DataBaseStr;
  end;
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    211:  //经轴入库管理
      begin
        if frmWarpRollerRklist = nil then
        begin
          frmWarpRollerRklist := TfrmWarpRollerRklist.Create(application.MainForm);
          with frmWarpRollerRklist do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWarpRollerRklist.BringToFront;
       //句柄
        mnewHandle := frmWarpRollerRklist.Handle;
      end;
    221:  //经轴出库管理
      begin
        if frmWarpRollerCklist = nil then
        begin
          frmWarpRollerCklist := TfrmWarpRollerCklist.Create(application.MainForm);
          with frmWarpRollerCklist do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWarpRollerCklist.BringToFront;
       //句柄
        mnewHandle := frmWarpRollerCklist.Handle;
      end;
    231:  //经轴库存管理
      begin
        if frmWarpRollerkCList = nil then
        begin
          frmWarpRollerkCList := TfrmWarpRollerkCList.Create(application.MainForm);
          with frmWarpRollerkCList do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWarpRollerkCList.BringToFront;
       //句柄
        mnewHandle := frmWarpRollerkCList.Handle;
      end;
    111:  //空轴入库管理
      begin
        if frmEmptyRollerRklist = nil then
        begin
          frmEmptyRollerRklist := TfrmEmptyRollerRklist.Create(application.MainForm);
          with frmEmptyRollerRklist do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmEmptyRollerRklist.BringToFront;
       //句柄
        mnewHandle := frmEmptyRollerRklist.Handle;
      end;
    121:  //空轴出库管理
      begin
        if frmEmptyRollerCklist = nil then
        begin
          frmEmptyRollerCklist := TfrmEmptyRollerCklist.Create(application.MainForm);
          with frmEmptyRollerCklist do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmEmptyRollerCklist.BringToFront;
       //句柄
        mnewHandle := frmEmptyRollerCklist.Handle;
      end;
    131:  //空轴库存管理
      begin
        if frmEmptyRollerkCList = nil then
        begin
          frmEmptyRollerkCList := TfrmEmptyRollerkCList.Create(application.MainForm);
          with frmEmptyRollerkCList do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmEmptyRollerkCList.BringToFront;
       //句柄
        mnewHandle := frmEmptyRollerkCList.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Warehouse) then
    DataLink_Warehouse := TDataLink_Warehouse.Create(Application);
  try
    with DataLink_Warehouse.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//
//finalization
//  DataLink_Warehouse.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_Warehouse.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

